// DFComExample.cpp : Definiert den Einstiegspunkt f�r die Konsolenanwendung.
//

//#include "stdafx.h"
//#pragma warning(disable : 4996)
#include "../include/api/df_api.h"
#include "../../shared/include/common/error_defines.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include <direct.h>

struct LSBF {
  char name[17];
  unsigned char typ;
  unsigned char len;
};

struct LSB {
  char name[17];
  unsigned char fieldCount;
  LSBF fields[25];
};

char g_listendaten[4000];

int list_import(char *file, const LSB &lsb)
{
  FILE *fp = NULL;
  char zeile[1024];
  char *token;
  char *pos;
  unsigned char columnIdx;
  int rowCount = 0;
  int i;

  memset(g_listendaten, 0, sizeof(g_listendaten));
  pos = g_listendaten;

  if ((fp = fopen(file, "rt")) == NULL) {
    printf("Oeffnen der Datei gescheitert.\n");
    return rowCount;
  }

  memset(zeile, 0, sizeof(zeile));
  while (fgets(zeile, sizeof(zeile), fp)) {

    if (zeile[strlen(zeile) - 1] == '\n') {
      zeile[strlen(zeile) - 1] = 0;
    }

    columnIdx = 0;
    token = strtok(zeile, "\t");
    while (token != NULL) {

      strcpy(pos, token);
      pos += strlen(token);
      for (i=0; i < int(lsb.fields[columnIdx].len - strlen(token)); i++) {

        *pos = '\0';
        pos++;
      }

      token = strtok(NULL, "\t");
      columnIdx++;
    }

    memset(zeile, 0, sizeof(zeile));
    rowCount++;
  }

  fclose(fp);
  return rowCount;
}

int main(int argc, char* argv[])
{
  int channelID = 1;
  char ip[32];
  int iError;
  int res;

  strcpy(ip, "192.168.123.35");

   
  int recordSize = 0;
  LSB lsb;
  memset(&lsb, 0, sizeof(LSB));
  strcpy(lsb.name, "Personal");
  lsb.fieldCount = 2;
  strcpy(lsb.fields[0].name, "PNr");
  lsb.fields[0].typ = 3;
  lsb.fields[0].len = 14;
  recordSize = lsb.fields[0].len;
  strcpy(lsb.fields[1].name, "Name");
  lsb.fields[1].typ = 4;
  lsb.fields[1].len = 21;
  recordSize += lsb.fields[1].len;

  if (DFCComOpenIV(channelID, 31, 3, ip, 8000, 3000) == 0) {

    printf("Schnittstelle konnte nicht geoeffnet werden.\n");
    system("pause");
    return 0;
  }
  printf("Verbindung zum Geraet hergestellt.\n");

  if ((res = list_import((char*)"Personal.txt", lsb)) > 0) {

    DFCClrListenBuffer(channelID);

    if (DFCMakeListe(channelID, 0, res, res * recordSize, (unsigned char*)g_listendaten, 0) == 0) {

      // Fehler bei Listendatenverarebeitung
      goto label_end;
    }

    if (DFCLoadListen(channelID, 254, &iError)) {

        printf("Listendaten uebertragen.\n");
    } else {
      printf("Fehler bei Listen�bertragung: %i\n", iError);
    }
  }

/*
  if (DFCGetSeriennummer(channelID, 254, &iError, &serial) == 0) {
    printf("Nachricht konnte nicht gesendet werden.\n");
    system("pause");
    goto label_end;
  }
  unsigned char dt[] = {20, 11, 4, 1, 11, 12, 13};

  if (DFCComSetTime(channelID, 254, dt) == 0) {
    printf("Uhrzeit konnte nicht gesendet werden.\n");
    system("pause");
    goto label_end;
  }


  sprintf(message, "Die Seriennummer von\rdiesem Ger�t ist:\r %i \rKaum zu glauben.\rKaum zu glauben.\rKaum zu glauben.\rKaum zu glauben.\rKaum zu glauben.\r", serial);

  if (DFCComSendMessage(channelID, 254, 30, 0, 3, message, strlen(message)) == 0) {
    printf("Nachricht konnte nicht gesendet werden.\n");
    system("pause");
    goto label_end;
  }
*/

label_end:
  DFCComClose(channelID);
  printf("Verbindung zum Geraet abgebaut.\n");

  return 0;
}
