#include "file/interface/dfitem/dfitem_menu_choice.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDFItemMenuChoice::CDFItemMenuChoice( NodeTypeID _type ) : CDFItemBase( _type )
{

}

CDFItemMenuChoice::~CDFItemMenuChoice()
{

}

int CDFItemMenuChoice::Modify( CModifyData &modifyData )
{
    int i;
    unsigned int offs = modifyData.offsFlash, offsChild;
    CDFItemBase *item = nullptr;
    StructBedien bedien;

    // Daten von MenueEintrag uebernehmen
    StructMenueEintrag &menuEintrag = *(StructMenueEintrag*)&modifyData.file->m_flash[offs - FLASH_KONFIG_START];
    offs += sizeof(StructMenueEintrag);
    
    // Passwort ersetzen?
    if ( modifyData.flags & SMDF_PASSWORD_MENU )
    {
        short password = LookupPassword( modifyData, menuEintrag.Name );
        if ( password != -1 )
        {
            menuEintrag.Pass = password;
        }
    }

    // Name aendern?
    strcpy( menuEintrag.Name, LookupReplace( modifyData, menuEintrag.Name ).c_str() );

    // Daten der Aktion einlesen
    // Bedien einlesen
    for ( i = 0; i < (int)menuEintrag.EintragCnt; ++i )
    {
        // Bedien einlesen
        offsChild = offs + i * sizeof(unsigned int);	// Pointer des Eintrags berechnen
        offsChild = *(unsigned int*)(&modifyData.file->m_flash[offsChild - FLASH_KONFIG_START]);
        ChangeOrderLong( (unsigned char*)&offsChild );
        
        bedien = *(StructBedien*)&modifyData.file->m_flash[offsChild - FLASH_KONFIG_START];

        switch ( bedien.Typ )
        {
        
            case TB_MENUE:
            { 
                item = new CDFItemMenu();
                break;
            }
        
            case TB_DATENSATZ:
            {
                item = new CDFItemInputChain();
                break;
            }
        }

        LinkEndChild( item );
        modifyData.offsFlash = offsChild;
        item->Modify( modifyData );
    }
        
    return 1;
}
